
//  Library to control servo
#include <Servo.h>

//Objects
Servo myServo;

//constants
//   Turntable
#define servoPin 9
#define touchPin 7

//   Color sensor
#define sensorPovPin 2
#define sensorAnalogValPin 1
#define colorSampling 10

//   Spoon
#define spoonPin 0
//     threshold
#define threshold 100

//  Button
#define buttonPin 5
#define buttonThreshold 50


//Variables
//   Turntable
int touchValue = 0;
int angle = 0;
int delayVar = 10;

//   Color sensor
int colorCounter = 0;
int colorVal = 0;
int lastColorVal = 0;
//   Spoon
//     measuring time over treshold
//int thresh = 1;
unsigned long int time = 0;

//  On/off
int onOff = 0;


void setup(){
  Serial.begin(9600);
  // Servo motor works only pin 9 and 10 on Arduiono NG
  myServo.attach(servoPin);
  pinMode(touchPin, INPUT);    // sets the digital pin as input
  //prepare  sensorPovPin
  pinMode(sensorPovPin, OUTPUT);
}

void checkButton(){
if(analogRead(buttonPin) < buttonThreshold){
  while( analogRead(buttonPin)< buttonThreshold)
    ;
    onOff = onOff == 0 ? 1 : 0;
  }
}

void loop(){
  int tValue = 0;
  checkButton();
  if(!onOff){
    delay(100);
  }else{
    //read spoon value
    readSpoon();
    
    //reads light value
    readLight();
    
    //do turntable motor stuff
    int tmp = digitalRead(touchPin);
    delayVar = 10;
    if(tmp != touchValue){
        touchValue = tmp;
        if (touchValue==HIGH) {
        angle = 0;
      }else{
         angle += 90;
         //delayVar = 200;
        }
        //Serial.println("Change direction");
        
    }else{
      
      if(touchValue==HIGH){
        angle = angle > 89 ? 0 : angle;
      }else{
        angle = angle > 180 ? 90 : angle;
        delayVar = 100;
      }
    }
    /*Serial.println(touchValue);
      Serial.println(angle);
      Serial.println(delayVar);*/
      // send value to the servo motor
      delay(delayVar);
      myServo.write(angle++);
      //int tValue = 0;
      if(time>0){
         tValue = time;
         time = 0;
      }
      
  }
  Serial.print(lastColorVal);
      Serial.print(";");
      Serial.print(tValue);
      Serial.print(";");
      Serial.print(touchValue);
      Serial.print(";");
      Serial.println(onOff);
}

//Our functions 
void readLight(){
  digitalWrite(sensorPovPin, HIGH);
  analogWrite(sensorAnalogValPin, 255);
  delay(1);
  colorVal += analogRead(sensorAnalogValPin);
  colorCounter++;
  digitalWrite(sensorPovPin, LOW);
  if(colorCounter==colorSampling){
    lastColorVal = colorVal/colorSampling;
    //Serial.println(lastColorVal);
    colorVal = 0;
    colorCounter = 0;
  }
}

void readSpoon(){
   int piezo = analogRead(spoonPin);
  // Serial.println(piezo);
   if(time==0 && piezo>=threshold){
     //piezo value just went above the threshold, start counting
     time = micros();
     while(piezo>=threshold){
          piezo = analogRead(spoonPin);
     }
     //piezo value just went under the threshold, calculate time
     time = micros() - time;
     //Serial.println(time);
    // time = 0;
   }
}


